#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/TFT/TFT eigene Programme/Touch_Calibration_MMPlus_Board/Touch_Calibration_MMPlus_Board_Code/mikroC PRO for PIC32/Touch_Calibration_MMPlus_Board_driver.c"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/touch_calibration_mmplus_board/touch_calibration_mmplus_board_code/mikroc pro for pic32/touch_calibration_mmplus_board_objects.h"
typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int LinesCount;
 TLine * const code *Lines;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel X_Min;
extern TLabel X_Max;
extern TLabel Y_Min;
extern TLabel Y_Max;
extern TLabel Label5;
extern TLabel Label6;
extern TLine Line1;
extern TLabel * const code Screen1_Labels[10];
extern TLine * const code Screen1_Lines[1];








extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char X_Min_Caption[];
extern char X_Max_Caption[];
extern char Y_Min_Caption[];
extern char Y_Max_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Line1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/touch_calibration_mmplus_board/touch_calibration_mmplus_board_code/mikroc pro for pic32/touch_calibration_mmplus_board_resources.h"
const code char OCR_A_Extended21x23_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 7 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/TFT/TFT eigene Programme/Touch_Calibration_MMPlus_Board/Touch_Calibration_MMPlus_Board_Code/mikroC PRO for PIC32/Touch_Calibration_MMPlus_Board_driver.c"
unsigned int TFT_DataPort at LATE;
sbit TFT_RST at LATC1_bit;
sbit TFT_RS at LATB15_bit;
sbit TFT_CS at LATF12_bit;
sbit TFT_RD at LATD5_bit;
sbit TFT_WR at LATD4_bit;
sbit TFT_BLED at LATC2_bit;
unsigned int TFT_DataPort_Direction at TRISE;
sbit TFT_RST_Direction at TRISC1_bit;
sbit TFT_RS_Direction at TRISB15_bit;
sbit TFT_CS_Direction at TRISF12_bit;
sbit TFT_RD_Direction at TRISD5_bit;
sbit TFT_WR_Direction at TRISD4_bit;
sbit TFT_BLED_Direction at TRISC2_bit;




unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TLabel *local_label;
TLabel *exec_label;
int label_order;


void PMPWaitBusy() {
 while(PMMODEbits.BUSY);
}

void Set_Index(unsigned short index) {
 TFT_RS = 0;
 PMDIN = index;
 PMPWaitBusy();
}

void Write_Command( unsigned short cmd ) {
TFT_RS = 1;
 PMDIN = cmd;
 PMPWaitBusy();
}

void Write_Data(unsigned int _data) {
TFT_RS = 1;
 PMDIN = _data;
 PMPWaitBusy();
}

static void InitializeTouchPanel() {
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963(480, 272);

 TFT_Set_DBC_SSD1963(255);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}

void Calibrate() {
 TFT_Fill_Screen(CL_BLACK);
 TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
 TFT_Write_Text("Touch points on the screen as they", 125, 121);
 TFT_Write_Text("appear to calibrate touchscreen.", 135, 151);
 STMPE610_ClearInterruptFlagsAndFIFO();
 TFT_Set_Brush(1, CL_WHITE, 0, 0, 0, 0);
 TFT_Circle(0, 0, 3);
 STMPE610_CalibratePoint(STMPE610_FIRST_CORNER);
 Delay_ms(500);
 TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
 TFT_Circle(0, 0, 3);
 STMPE610_ClearInterruptFlagsAndFIFO();
 TFT_Set_Brush(1, CL_WHITE, 0, 0, 0, 0);
 TFT_Circle(0, TFT_DISP_HEIGHT-1, 3);
 STMPE610_CalibratePoint(STMPE610_SECOND_CORNER);
 Delay_ms(500);
 TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
 TFT_Circle(0, TFT_DISP_HEIGHT-1, 3);
 STMPE610_ClearInterruptFlagsAndFIFO();
 TFT_Set_Brush(1, CL_WHITE, 0, 0, 0, 0);
 TFT_Circle(TFT_DISP_WIDTH-1, TFT_DISP_HEIGHT-1, 3);
 STMPE610_CalibratePoint(STMPE610_THIRD_CORNER);
 Delay_ms(500);
 TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
 TFT_Circle(TFT_DISP_WIDTH-1, TFT_DISP_HEIGHT-1, 3);
 STMPE610_ClearInterruptFlagsAndFIFO();
 TFT_Set_Brush(1, CL_WHITE, 0, 0, 0, 0);
 TFT_Circle(TFT_DISP_WIDTH-1, 0, 3);
 STMPE610_CalibratePoint(STMPE610_FOURTH_CORNER);
 TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
 TFT_Circle(TFT_DISP_WIDTH-1, 0, 3);
 Delay_ms(500);
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TLabel Label1;
char Label1_Caption[6] = "X_Min";

 TLabel Label2;
char Label2_Caption[6] = "X_Max";

 TLabel Label3;
char Label3_Caption[6] = "Y_Min";

 TLabel Label4;
char Label4_Caption[6] = "Y_Max";

 TLabel X_Min;
char X_Min_Caption[21] = "Text";

 TLabel X_Max;
char X_Max_Caption[21] = "Text";

 TLabel Y_Min;
char Y_Min_Caption[21] = "Text";

 TLabel Y_Max;
char Y_Max_Caption[21] = "Text";

 TLabel Label5;
char Label5_Caption[26] = "Mikromedia Plus - STMP610";

 TLabel Label6;
char Label6_Caption[18] = "touch calibration";

 TLine Line1;
 TLabel * const code Screen1_Labels[10]=
 {
 &Label1,
 &Label2,
 &Label3,
 &Label4,
 &X_Min,
 &X_Max,
 &Y_Min,
 &Y_Max,
 &Label5,
 &Label6
 };
 TLine * const code Screen1_Lines[1]=
 {
 &Line1
 };



static void InitializeObjects() {
 Screen1.Color = 0x5AEB;
 Screen1.Width = 480;
 Screen1.Height = 272;
 Screen1.LabelsCount = 10;
 Screen1.Labels = Screen1_Labels;
 Screen1.LinesCount = 1;
 Screen1.Lines = Screen1_Lines;
 Screen1.ObjectsCount = 11;


 Label1.OwnerScreen = &Screen1;
 Label1.Order = 0;
 Label1.Left = 54;
 Label1.Top = 114;
 Label1.Width = 65;
 Label1.Height = 24;
 Label1.Visible = 1;
 Label1.Active = 1;
 Label1.Caption = Label1_Caption;
 Label1.FontName = OCR_A_Extended21x23_Regular;
 Label1.Font_Color = 0xFFFF;
 Label1.OnUpPtr = 0;
 Label1.OnDownPtr = 0;
 Label1.OnClickPtr = 0;
 Label1.OnPressPtr = 0;

 Label2.OwnerScreen = &Screen1;
 Label2.Order = 1;
 Label2.Left = 54;
 Label2.Top = 142;
 Label2.Width = 65;
 Label2.Height = 24;
 Label2.Visible = 1;
 Label2.Active = 1;
 Label2.Caption = Label2_Caption;
 Label2.FontName = OCR_A_Extended21x23_Regular;
 Label2.Font_Color = 0xFFFF;
 Label2.OnUpPtr = 0;
 Label2.OnDownPtr = 0;
 Label2.OnClickPtr = 0;
 Label2.OnPressPtr = 0;

 Label3.OwnerScreen = &Screen1;
 Label3.Order = 2;
 Label3.Left = 54;
 Label3.Top = 172;
 Label3.Width = 65;
 Label3.Height = 24;
 Label3.Visible = 1;
 Label3.Active = 1;
 Label3.Caption = Label3_Caption;
 Label3.FontName = OCR_A_Extended21x23_Regular;
 Label3.Font_Color = 0xFFFF;
 Label3.OnUpPtr = 0;
 Label3.OnDownPtr = 0;
 Label3.OnClickPtr = 0;
 Label3.OnPressPtr = 0;

 Label4.OwnerScreen = &Screen1;
 Label4.Order = 3;
 Label4.Left = 54;
 Label4.Top = 202;
 Label4.Width = 65;
 Label4.Height = 24;
 Label4.Visible = 1;
 Label4.Active = 1;
 Label4.Caption = Label4_Caption;
 Label4.FontName = OCR_A_Extended21x23_Regular;
 Label4.Font_Color = 0xFFFF;
 Label4.OnUpPtr = 0;
 Label4.OnDownPtr = 0;
 Label4.OnClickPtr = 0;
 Label4.OnPressPtr = 0;

 X_Min.OwnerScreen = &Screen1;
 X_Min.Order = 4;
 X_Min.Left = 131;
 X_Min.Top = 114;
 X_Min.Width = 52;
 X_Min.Height = 24;
 X_Min.Visible = 1;
 X_Min.Active = 1;
 X_Min.Caption = X_Min_Caption;
 X_Min.FontName = OCR_A_Extended21x23_Regular;
 X_Min.Font_Color = 0xFFFF;
 X_Min.OnUpPtr = 0;
 X_Min.OnDownPtr = 0;
 X_Min.OnClickPtr = 0;
 X_Min.OnPressPtr = 0;

 X_Max.OwnerScreen = &Screen1;
 X_Max.Order = 5;
 X_Max.Left = 131;
 X_Max.Top = 142;
 X_Max.Width = 52;
 X_Max.Height = 24;
 X_Max.Visible = 1;
 X_Max.Active = 1;
 X_Max.Caption = X_Max_Caption;
 X_Max.FontName = OCR_A_Extended21x23_Regular;
 X_Max.Font_Color = 0xFFFF;
 X_Max.OnUpPtr = 0;
 X_Max.OnDownPtr = 0;
 X_Max.OnClickPtr = 0;
 X_Max.OnPressPtr = 0;

 Y_Min.OwnerScreen = &Screen1;
 Y_Min.Order = 6;
 Y_Min.Left = 131;
 Y_Min.Top = 172;
 Y_Min.Width = 52;
 Y_Min.Height = 24;
 Y_Min.Visible = 1;
 Y_Min.Active = 1;
 Y_Min.Caption = Y_Min_Caption;
 Y_Min.FontName = OCR_A_Extended21x23_Regular;
 Y_Min.Font_Color = 0xFFFF;
 Y_Min.OnUpPtr = 0;
 Y_Min.OnDownPtr = 0;
 Y_Min.OnClickPtr = 0;
 Y_Min.OnPressPtr = 0;

 Y_Max.OwnerScreen = &Screen1;
 Y_Max.Order = 7;
 Y_Max.Left = 131;
 Y_Max.Top = 202;
 Y_Max.Width = 52;
 Y_Max.Height = 24;
 Y_Max.Visible = 1;
 Y_Max.Active = 1;
 Y_Max.Caption = Y_Max_Caption;
 Y_Max.FontName = OCR_A_Extended21x23_Regular;
 Y_Max.Font_Color = 0xFFFF;
 Y_Max.OnUpPtr = 0;
 Y_Max.OnDownPtr = 0;
 Y_Max.OnClickPtr = 0;
 Y_Max.OnPressPtr = 0;

 Label5.OwnerScreen = &Screen1;
 Label5.Order = 8;
 Label5.Left = 54;
 Label5.Top = 32;
 Label5.Width = 327;
 Label5.Height = 24;
 Label5.Visible = 1;
 Label5.Active = 1;
 Label5.Caption = Label5_Caption;
 Label5.FontName = OCR_A_Extended21x23_Regular;
 Label5.Font_Color = 0xFFFF;
 Label5.OnUpPtr = 0;
 Label5.OnDownPtr = 0;
 Label5.OnClickPtr = 0;
 Label5.OnPressPtr = 0;

 Label6.OwnerScreen = &Screen1;
 Label6.Order = 9;
 Label6.Left = 54;
 Label6.Top = 54;
 Label6.Width = 222;
 Label6.Height = 24;
 Label6.Visible = 1;
 Label6.Active = 1;
 Label6.Caption = Label6_Caption;
 Label6.FontName = OCR_A_Extended21x23_Regular;
 Label6.Font_Color = 0xFFFF;
 Label6.OnUpPtr = 0;
 Label6.OnDownPtr = 0;
 Label6.OnClickPtr = 0;
 Label6.OnPressPtr = 0;

 Line1.OwnerScreen = &Screen1;
 Line1.Order = 10;
 Line1.First_Point_X = 56;
 Line1.First_Point_Y = 79;
 Line1.Second_Point_X = 384;
 Line1.Second_Point_Y = 78;
 Line1.Visible = 1;
 Line1.Pen_Width = 2;
 Line1.Color = 0xFFFF;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}






void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible == 1) {
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawLine(TLine *Aline) {
 if (Aline->Visible == 1) {
 TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
 TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short label_idx;
 TLabel *local_label;
 unsigned short line_idx;
 TLine *local_line;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 label_idx = 0;
 line_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 save_bled_direction = TFT_BLED_Direction;
 TFT_BLED_Direction = 0;
 TFT_BLED = 0;
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963(CurrentScreen->Width, CurrentScreen->Height);
 STMPE610_SetSize(CurrentScreen->Width, CurrentScreen->Height);
 TFT_Fill_Screen(CurrentScreen->Color);
 TFT_Set_DBC_SSD1963(255);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 TFT_BLED_Direction = save_bled_direction;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 if (line_idx < CurrentScreen->LinesCount) {
 local_line =  CurrentScreen->Lines[line_idx] ;
 if (order == local_line->Order) {
 line_idx++;
 order++;
 DrawLine(local_line);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 label_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
 local_label =  CurrentScreen->Labels[_object_count] ;
 if (local_label->Active == 1) {
 if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
 local_label->Width, local_label->Height) == 1) {
 label_order = local_label->Order;
 exec_label = local_label;
 }
 }
 }

 _object_count = -1;
 if (label_order > _object_count )
 _object_count = label_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_label = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnPressPtr != 0) {
 exec_label->OnPressPtr();
 return;
 }
 }
 }

 }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

 exec_label = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnUpPtr != 0)
 exec_label->OnUpPtr();
 if (PressedObject == (void *)exec_label)
 if (exec_label->OnClickPtr != 0)
 exec_label->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_label = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 PressedObject = (void *)exec_label;
 PressedObjectType = 2;
 if (exec_label->OnDownPtr != 0) {
 exec_label->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (STMPE610_PressDetect()) {
 if (STMPE610_GetLastCoordinates(&Xcoord, &Ycoord) == 0) {

 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {
 AD1PCFG = 0xFFFF;
 JTAGEN_bit = 0;

 TRISA2_bit = 0;
 TRISA3_bit = 1;
 LATA2_bit = 1;
 while (PORTA.B3 == 0) {
 LATA2_bit = 0;
 Delay_us(10);
 LATA2_bit = 1;
 Delay_us(10);
 }

 I2C2_Init(100000);

 PMMODE = 0;
 PMAEN = 0;
 PMCON = 0;
 PMMODEbits.MODE = 2;
 PMMODEbits.WAITB = 0;
 PMMODEbits.WAITM = 1;
 PMMODEbits.WAITE = 0;
 PMMODEbits.MODE16 = 1;
 PMCONbits.CSF = 0;
 PMCONbits.PTRDEN = 1;
 PMCONbits.PTWREN = 1;
 PMCONbits.PMPEN = 1;
 TFT_Set_Default_Mode();
 STMPE610_SetDefaultMode();
 TFT_Set_MM_Plus();
}

char STMPE610_Config() {
 STMPE610_SetI2CAddress(STMPE610_I2C_ADDR1);
 if (STMPE610_IsOperational() != 0){
 return STMPE610_IO_NOT_OPERATIONAL;
 }

 STMPE610_Reset();
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN1, STMPE610_ENABLE);
 STMPE610_SetGPIOPin(STMPE610_GPIO_PIN1, 0);
 STMPE610_SetSize(480,272);
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_EnableInterrupt(0, STMPE610_ENABLE);
 STMPE610_ConfigureInterrupt(STMPE610_INT_POLARITY_ACTIVE_HIGH | STMPE610_INT_TYPE_EDGE | STMPE610_INT_ENABLE_ALL);
 STMPE610_SetADC(STMPE610_ADC_CTRL1_SAMPLETIME_56 | STMPE610_ADC_CTRL1_ADC_12BIT | STMPE610_ADC_CTRL1_INT_REFERENCE);
 Delay_10ms(); Delay_10ms();
 STMPE610_SetADCClock(STMPE610_ADC_CTRL2_3250_kHZ);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN4 | STMPE610_GPIO_PIN5 | STMPE610_GPIO_PIN6 | STMPE610_GPIO_PIN7, STMPE610_DISABLE);
 STMPE610_ConfigureTSC(STMPE610_TSC_CFG_AVE_CTRL_4S, STMPE610_TSC_CFG_TOUCH_DET_DELAY_500uS, STMPE610_TSC_CFG_TOUCH_SETTLING_1mS);
 STMPE610_SetFIFOThreshold(1);
 STMPE610_ResetFIFO();
 STMPE610_TSIDrive(STMPE610_TSC_I_DRIVE_20mA);
 STMPE610_TSControl(STMPE610_TSC_CTRL_TRACK0 | STMPE610_TSC_CTRL_ACQU_XYZ | STMPE610_TSC_CTRL_ENABLE);
 STMPE610_ZDataFraction(STMPE610_FRACP4_WHOLP4);
 STMPE610_SetTouchPressureThreshold(70);
 STMPE610_ClearInterrupts();
 STMPE610_WriteReg(STMPE610_INT_CTRL_REG, 0x01);
 return STMPE610_OK;
}


void Start_TP() {
 Init_MCU();

 InitializeTouchPanel();
 if (STMPE610_Config() == STMPE610_OK) {
 } else {
 while(1);
 }


 Delay_ms(1000);
 TFT_Fill_Screen(0);
 Calibrate();
 TFT_Fill_Screen(0);

 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}
